%define _prefix /usr/local/kde

Summary: LinCVS is a frontend for the version revision system CVS
Name: lincvs
Version: 0.4.0
Release: 0
Copyright: GPL
Group: Development/Tools
Provides: %{name}
Source: %{name}-%{version}.tar.gz
Distribution: SuSE Linux 7.0 (i386)
BuildRoot: /var/tmp/%{name}-%{version}-buildroot
# The BuildRoot specifies where RPM will look for the files in the %files
# section (i.e. relative to the BuildRoot), and also sets the value of the
# $RPM_BUILD_ROOT variable. The default, '/', causes the %{name} utility
# to be ACTUALLY INSTALLED on the BUILD system (the system where the RPM
# is created). It also requires 'rpm -bb [specfile]' to be run as root.
Packager: Dr. Johann Pfefferl <johann.pfefferl.jp@germany.agfa.com>
Vendor: Tilo Riemer
%description
LinCVS enhances the ease-of-use of CVS by providing a simple,
intuitive graphic interface to CVS. With the GUI and mouse, you
can quickly and easily review the CVS status of files or groups
of files or of entire directory trees. You can also quickly
initiate common CVS commands without the need for typing long
command lines with many option flags.

Authors:
--------
    see AUTHORS file

%prep
%setup
rm -rf $RPM_BUILD_ROOT

%build
# restrict the PATH to its minimum, so that the configure script does not find tools
# in non standard directories
PATH=/bin:/usr/bin:/usr/sbin:$PATH
CXXFLAGS=$RPM_OPT_FLAGS ./configure --prefix=%{_prefix} --with-kde2-support
make

%install
make install-strip prefix=$RPM_BUILD_ROOT%{_prefix}
{
	# build directory lists
	find $RPM_BUILD_ROOT -type d -mindepth 1 |
	  sed -e "s#^$RPM_BUILD_ROOT#%attr(-, root, root) %dir #g"

	# build doc file list
	if [ -d $RPM_BUILD_ROOT%{_prefix}/info -o -d $RPM_BUILD_ROOT%{_prefix}/man ]
	then
		find $RPM_BUILD_ROOT -type f \( -path '*%{_prefix}/info/*.info*' -o -path '*%{_prefix}/man/*' \) |
		  sed -e "s#^$RPM_BUILD_ROOT#%attr(-, root, root) %doc #g"
	fi
	
	for f in AUTHORS BUGS COPYING NEWS README* TODO SSH.txt VERSION.TXT
	do
	  [ -f $f ] && echo "%attr(-, root, root) %doc $f"
	done

	# build config file list
	if [ -d $RPM_BUILD_ROOT%{_prefix}/etc ]
	then
		find $RPM_BUILD_ROOT -type f -path '*%{_prefix}/etc/*' |
		  sed -e "s#^$RPM_BUILD_ROOT#%attr(-, root, root) %config #g"
	fi

	# build rest of file list
	find $RPM_BUILD_ROOT -type f ! \( -path '*%{_prefix}/etc/*' -o -path '*%{_prefix}/info/*' -o -path '*%{_prefix}/man/*' \) |
	  sed -e "s#^$RPM_BUILD_ROOT#%attr(-, root, root) #g"
} > rpm-files

%post

%postun

%clean
rm -rf $RPM_BUILD_ROOT

%files -f rpm-files

## vim: tw=0
