/****************************************************************************
**
** $Id: MergeDialogImpl.cpp,v 1.1 2001/11/01 09:13:07 riemer Exp $
**
** Copyright (C) 2001 The LinCVS development team.
**    Tilo Riemer <riemer@lincvs.org>
**    Falk Brettschneider <gigafalk@yahoo.com>
**    Wim Delvaux <wim.delvaux@chello.be>
**    Jose Hernandez <joseh@tesco.net>
**    Helmut Koll <HelmutKoll@web.de>
**    Sven Trogisch <trogisch@iapp.de>
**
**
**----------------------------------------------------------------------------
**
**----------------------------------------------------------------------------
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as
** published by the Free Software Foundation; either version 2 of the
** License, or (at your option) any later version.
**
*****************************************************************************/


#include "config.h"
#include "ac_system_defs.h"


#include <qfileinfo.h>
#include <qlistview.h>
#include "CmdThread.h"
#include "CvsFileViewer.h"
#include "MergeDialogImpl.h"


/*!!***************************************************************************
 *!! FUNCTION NAME
 *!!    MergeDialogImpl
 *!!
 *!! PARAMETERS
 *!!
 *!!
 *!! RETURN VALUE
 *!!    none
 *!!
 *!! GLOBALS ACCESSED
 *!!    none
 *!!
 *!! DESCRIPTION
 *!!    Constructs a AnnotateDialogImpl which is a child of 'parent', with the 
 *!!    name 'name' and widget flags set to 'f' 
 *!!    The dialog will by default be modeless, unless you set 'modal' to
 *!!    TRUE to construct a modal dialog.
 *!!**************************************************************************/

MergeDialogImpl::MergeDialogImpl (QWidget* parent, const char* name,
					bool modal, WFlags fl )
	: MergeDialog( parent, name, modal, fl )
{
}


/*!!***************************************************************************
 *!! FUNCTION NAME
 *!!    ~MergeDialogImpl
 *!!
 *!! PARAMETERS
 *!!    none
 *!!
 *!! RETURN VALUE
 *!!    none
 *!!
 *!! GLOBALS ACCESSED
 *!!    none
 *!!
 *!! DESCRIPTION
 *!!    Destroys the object and frees any allocated resources
 *!!
 *!!**************************************************************************/

MergeDialogImpl::~MergeDialogImpl()
{
}








