/*!!***************************************************************************
 *!! FILE NAME
 *!!	$Source: /var/cvs/pub/repository/LinCVS/src/TagDialogImpl.h,v $
 *!!
 *!! AUTHOR
 *!!	$Author: joseh $
 *!!
 *!! DATE, REVISION AND STATE
 *!!	$Date: 2001/07/18 23:10:27 $
 *!!	$Revision: 1.1 $
 *!!	$State: Exp $
 *!!
 *!! DESCRIPTION
 *!!
 *!!	Copyright (C) 2001 The LinCVS development team.
 *!!	    Tilo Riemer <riemer@lincvs.org>
 *!!	    Falk Brettschneider <gigafalk@yahoo.com>
 *!!	    Wim Delvaux <wim.delvaux@chello.be>
 *!!	    Jose Hernandez <joseh@tesco.net>
 *!!        Helmut Koll <HelmutKoll@web.de>
 *!!	    Sven Trogisch <trogisch@iapp.de>
 *!!
 *!!	This program is free software; you can redistribute it and/or modify
 *!!	it under the terms of the GNU General Public License as published by
 *!!	the Free Software Foundation; either version 2, or (at your option)
 *!!	any later version.
 *!!
 *!!	This program is distributed in the hope that it will be useful,
 *!!	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *!!	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *!!	GNU General Public License for more details.
 *!!
 *!!**************************************************************************/


#ifndef TAGDIALOGIMPL_H
#define TAGDIALOGIMPL_H
#include "TagDialog.h"


class QStringList;


class TagDialogImpl : public TagDialog
{ 
	Q_OBJECT

public:

	enum DIALOG_RET_CODE_E
	{
		TAG_REGULAR = 1,
		TAG_BRANCH = 2,
		TAG_DELETE = 3
	};

	TagDialogImpl( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~TagDialogImpl();

	void initTagList (QStringList *pTagList);

protected slots:
        virtual void accept ();

private:
	QStringList *m_pTagList;
};


#endif // TAGDIALOGIMPL_H
